<?php

/**
 * Vvveb
 *
 * Copyright (C) 2022  Ziadin Givan
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

namespace Vvveb\Plugins\BankTransferPayment;

use function Vvveb\getLanguageId;
use function Vvveb\getMultiSettingContent;
use Vvveb\System\PaymentMethod;

if (! defined('V_VERSION')) {
	die('Invalid request!');
}

class Payment extends PaymentMethod {
	private $namespace = 'bank-transfer';

	public function getMethod() {
		$method_data = [
			'name'           => $this->namespace,
			'title'          => 'Bank transfer',
			'description'    => 'Bank transfer details',
			'cost'           => 0,
			'tax'            => 1,
			'region_id'      => 1,
		];

		//$settings = \Vvveb\getSetting($this->namespace);
		$language_id = getLanguageId();
		$lang        = getMultiSettingContent(SITE_ID, $this->namespace, [], $language_id) ?? [];

		foreach ($lang as $meta) {
			$desc[$meta['language_id']][$meta['key']] = $meta['value'];
		}

		$method_data['description'] = $desc[$language_id]['desc']['message'] ?? $method_data['description'];
		$method_data['title']       = $desc[$language_id]['desc']['name'] ?? $method_data['title'];

		return $method_data;
	}

	public function init() {
	}

	public function setMethod() {
	}
}
